test-lib: enable MALLOC_* for the actual tests
[git/git.git] / t / test-lib.sh
CommitLineData
e1970ce4
JH
1#!/bin/sh
2#
3# Copyright (c) 2005 Junio C Hamano
4#
64b90323
MS
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 2 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see http://www.gnu.org/licenses/ .
e1970ce4 17
c2116a17
JH
18# Keep the original TERM for say_color
19ORIGINAL_TERM=$TERM
20
3c8f12c9
JH
21# Test the binaries we have just built. The tests are kept in
22# t/ subdirectory and are run in 'trash directory' subdirectory.
23if test -z "$TEST_DIRECTORY"
24then
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
27 # itself.
28 TEST_DIRECTORY=$(pwd)
29fi
30if test -z "$TEST_OUTPUT_DIRECTORY"
31then
32 # Similarly, override this to store the test-results subdir
33 # elsewhere
34 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
35fi
36GIT_BUILD_DIR="$TEST_DIRECTORY"/..
37
2006f0ad
RR
38################################################################
39# It appears that people try to run tests without building...
40"$GIT_BUILD_DIR/git" >/dev/null
41if test $? != 1
42then
43 echo >&2 'error: you do not seem to have built git yet.'
44 exit 1
45fi
46
3c8f12c9
JH
47. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
48export PERL_PATH SHELL_PATH
49
4cde519f
RR
50# if --tee was passed, write the output not only to the terminal, but
51# additionally to the file test-results/$BASENAME.out, too.
52case "$GIT_TEST_TEE_STARTED, $* " in
53done,*)
54 # do not redirect again
55 ;;
56*' --tee '*|*' --va'*)
57 mkdir -p test-results
58 BASE=test-results/$(basename "$0" .sh)
59 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
60 echo $? > $BASE.exit) | tee $BASE.out
61 test "$(cat $BASE.exit)" = 0
62 exit
63 ;;
64esac
65
e1970ce4
JH
66# For repeatability, reset the environment to known value.
67LANG=C
899460f3 68LC_ALL=C
d9bdd39e 69PAGER=cat
e1970ce4 70TZ=UTC
c2116a17
JH
71TERM=dumb
72export LANG LC_ALL PAGER TERM TZ
8ff99e74 73EDITOR=:
661bfd13
SL
74# A call to "unset" with no arguments causes at least Solaris 10
75# /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
76# deriving from the command substitution clustered with the other
77# ones.
3c8f12c9 78unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
95a1d12e 79 my @env = keys %ENV;
730477f1
JL
80 my $ok = join("|", qw(
81 TRACE
82 DEBUG
83 USE_LOOKUP
84 TEST
85 .*_TEST
86 PROVE
87 VALGRIND
ac001282 88 UNZIP
edb54081 89 PERF_
730477f1
JL
90 ));
91 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
95a1d12e
JN
92 print join("\n", @vars);
93')
5adf84eb 94unset XDG_CONFIG_HOME
29e55cd5
JH
95GIT_AUTHOR_EMAIL=author@example.com
96GIT_AUTHOR_NAME='A U Thor'
29e55cd5
JH
97GIT_COMMITTER_EMAIL=committer@example.com
98GIT_COMMITTER_NAME='C O Mitter'
8d0fc48f 99GIT_MERGE_VERBOSITY=5
f8246281
JH
100GIT_MERGE_AUTOEDIT=no
101export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
29e55cd5
JH
102export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
103export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
d33738d7 104export EDITOR
e1970ce4 105
a731fa91
EP
106# Add libc MALLOC and MALLOC_PERTURB test
107# only if we are not executing the test with valgrind
1b3185fc 108if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
ee1431bf 109 test -n "$TEST_NO_MALLOC_CHECK"
1b3185fc
JH
110then
111 setup_malloc_check () {
112 : nothing
113 }
114 teardown_malloc_check () {
115 : nothing
116 }
117else
118 setup_malloc_check () {
119 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
120 export MALLOC_CHECK_ MALLOC_PERTURB_
121 }
122 teardown_malloc_check () {
123 unset MALLOC_CHECK_ MALLOC_PERTURB_
124 }
125fi
a731fa91 126
886a3907
JH
127# Protect ourselves from common misconfiguration to export
128# CDPATH into the environment
129unset CDPATH
130
5565f47c 131unset GREP_OPTIONS
ac001282 132unset UNZIP
5565f47c 133
3d5c0cc9 134case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
1c0cc756
RJ
1351|2|true)
136 echo "* warning: Some tests will not work if GIT_TRACE" \
137 "is set as to trace on STDERR ! *"
138 echo "* warning: Please set GIT_TRACE to something" \
139 "other than 1, 2 or true ! *"
140 ;;
6ce4e61f
CC
141esac
142
cd3c095c
JH
143# Convenience
144#
145# A regexp to match 5 and 40 hexdigits
146_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
147_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
148
3749fde5
JH
149# Zero SHA-1
150_z40=0000000000000000000000000000000000000000
151
3f4ab627
JH
152# Line feed
153LF='
154'
155
342e9ef2
TR
156export _x05 _x40 _z40 LF
157
e1970ce4
JH
158# Each test should start with something like this, after copyright notices:
159#
160# test_description='Description of this test...
161# This test checks if command xyzzy does the right thing...
162# '
163# . ./test-lib.sh
c2116a17
JH
164[ "x$ORIGINAL_TERM" != "xdumb" ] && (
165 TERM=$ORIGINAL_TERM &&
166 export TERM &&
167 [ -t 1 ] &&
168 tput bold >/dev/null 2>&1 &&
169 tput setaf 1 >/dev/null 2>&1 &&
170 tput sgr0 >/dev/null 2>&1
171 ) &&
55db1df0 172 color=t
e1970ce4 173
e1970ce4
JH
174while test "$#" -ne 0
175do
176 case "$1" in
177 -d|--d|--de|--deb|--debu|--debug)
178 debug=t; shift ;;
886856ab
JH
179 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
180 immediate=t; shift ;;
5e2c08c6 181 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
91e80b98 182 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
e1970ce4 183 -h|--h|--he|--hel|--help)
570f3226 184 help=t; shift ;;
e1970ce4
JH
185 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
186 verbose=t; shift ;;
1ece1274 187 -q|--q|--qu|--qui|--quie|--quiet)
092c4334
ÆAB
188 # Ignore --quiet under a TAP::Harness. Saying how many tests
189 # passed without the ok/not ok details is always an error.
190 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
e4597aae
MO
191 --with-dashes)
192 with_dashes=t; shift ;;
55db1df0 193 --no-color)
faa4bc35 194 color=; shift ;;
4e1be63c 195 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
952af351
TR
196 valgrind=memcheck
197 shift ;;
198 --valgrind=*)
199 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
200 shift ;;
44138559
JS
201 --tee)
202 shift ;; # was handled already
f423ef5f
JK
203 --root=*)
204 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
205 shift ;;
e1970ce4 206 *)
1f729dca 207 echo "error: unknown test option '$1'" >&2; exit 1 ;;
e1970ce4
JH
208 esac
209done
210
952af351
TR
211test -n "$valgrind" && verbose=t
212
1c0cc756
RJ
213if test -n "$color"
214then
55db1df0 215 say_color () {
c2116a17
JH
216 (
217 TERM=$ORIGINAL_TERM
218 export TERM
55db1df0 219 case "$1" in
1c0cc756
RJ
220 error)
221 tput bold; tput setaf 1;; # bold red
222 skip)
b8fc855a 223 tput setaf 4;; # blue
e8e51955
AS
224 warn)
225 tput setaf 3;; # brown/yellow
1c0cc756 226 pass)
0a6d4751 227 tput setaf 2;; # green
1c0cc756 228 info)
0a6d4751 229 tput setaf 6;; # cyan
1c0cc756
RJ
230 *)
231 test -n "$quiet" && return;;
55db1df0
PH
232 esac
233 shift
5099b99d 234 printf "%s" "$*"
55db1df0 235 tput sgr0
b8eecafd 236 echo
c2116a17 237 )
55db1df0
PH
238 }
239else
240 say_color() {
1ece1274 241 test -z "$1" && test -n "$quiet" && return
55db1df0 242 shift
7bc0911d 243 printf "%s\n" "$*"
55db1df0
PH
244 }
245fi
246
247error () {
248 say_color error "error: $*"
6e7b5aaf 249 GIT_EXIT_OK=t
55db1df0
PH
250 exit 1
251}
252
253say () {
254 say_color info "$*"
255}
256
570f3226
MB
257test "${test_description}" != "" ||
258error "Test script did not set test_description."
259
260if test "$help" = "t"
261then
262 echo "$test_description"
263 exit 0
264fi
265
4d9d62fa 266exec 5>&1
781f76b1 267exec 6<&0
e1970ce4
JH
268if test "$verbose" = "t"
269then
270 exec 4>&2 3>&1
271else
272 exec 4>/dev/null 3>/dev/null
273fi
274
275test_failure=0
276test_count=0
41ac414e
JH
277test_fixed=0
278test_broken=0
2d84e9fb 279test_success=0
e1970ce4 280
d998bd4a
ÆAB
281test_external_has_tap=0
282
faa4bc35 283die () {
6e7b5aaf
CB
284 code=$?
285 if test -n "$GIT_EXIT_OK"
286 then
287 exit $code
288 else
289 echo >&5 "FATAL: Unexpected exit with code $code"
290 exit 1
291 fi
faa4bc35
CB
292}
293
6e7b5aaf 294GIT_EXIT_OK=
35641310 295trap 'die' EXIT
41184273 296
12a29b1a
TR
297# The user-facing functions are loaded from a separate file so that
298# test_perf subshells can have them too
3c8f12c9 299. "$TEST_DIRECTORY/test-lib-functions.sh"
05236a5e 300
886856ab
JH
301# You are not expected to call test_ok_ and test_failure_ directly, use
302# the text_expect_* functions instead.
303
304test_ok_ () {
d5d9de1b 305 test_success=$(($test_success + 1))
5099b99d 306 say_color "" "ok $test_count - $@"
e1970ce4
JH
307}
308
886856ab 309test_failure_ () {
d5d9de1b 310 test_failure=$(($test_failure + 1))
5e5c006e 311 say_color error "not ok $test_count - $1"
bf0dd8a8 312 shift
5099b99d 313 echo "$@" | sed -e 's/^/# /'
6e7b5aaf 314 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
886856ab
JH
315}
316
41ac414e 317test_known_broken_ok_ () {
41ac414e 318 test_fixed=$(($test_fixed+1))
b73d9a23 319 say_color error "ok $test_count - $@ # TODO known breakage vanished"
41ac414e
JH
320}
321
322test_known_broken_failure_ () {
41ac414e 323 test_broken=$(($test_broken+1))
e8e51955 324 say_color warn "not ok $test_count - $@ # TODO known breakage"
41ac414e 325}
886856ab
JH
326
327test_debug () {
8e832ebc 328 test "$debug" = "" || eval "$1"
e1970ce4
JH
329}
330
a7c58f28
JN
331test_eval_ () {
332 # This is a separate function because some tests use
333 # "return" to end a test_expect_success block early.
781f76b1 334 eval </dev/null >&3 2>&4 "$*"
a7c58f28
JN
335}
336
4d9d62fa 337test_run_ () {
b6b0afdc 338 test_cleanup=:
b586744a 339 expecting_failure=$2
a57397b0 340 setup_malloc_check
a7c58f28 341 test_eval_ "$1"
b6b0afdc 342 eval_ret=$?
a57397b0 343 teardown_malloc_check
b586744a
JH
344
345 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
346 then
1b3185fc 347 setup_malloc_check
a7c58f28 348 test_eval_ "$test_cleanup"
1b3185fc 349 teardown_malloc_check
b586744a 350 fi
1c0cc756
RJ
351 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
352 then
57e1538a
ÆAB
353 echo ""
354 fi
aa0bcf96 355 return "$eval_ret"
4d9d62fa
PR
356}
357
04ece593 358test_skip () {
8586f98b 359 test_count=$(($test_count+1))
04ece593
JH
360 to_skip=
361 for skp in $GIT_SKIP_TESTS
362 do
8586f98b 363 case $this_test.$test_count in
04ece593
JH
364 $skp)
365 to_skip=t
47e67d47 366 break
04ece593
JH
367 esac
368 done
05236a5e
JN
369 if test -z "$to_skip" && test -n "$test_prereq" &&
370 ! test_have_prereq "$test_prereq"
a7bb3940
JS
371 then
372 to_skip=t
373 fi
04ece593
JH
374 case "$to_skip" in
375 t)
07431fc8 376 of_prereq=
05236a5e 377 if test "$missing_prereq" != "$test_prereq"
07431fc8 378 then
05236a5e 379 of_prereq=" of $test_prereq"
07431fc8
JN
380 fi
381
55db1df0 382 say_color skip >&3 "skipping test: $@"
07431fc8 383 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
04ece593
JH
384 : true
385 ;;
386 *)
387 false
388 ;;
389 esac
390}
391
342e9ef2
TR
392# stub; perf-lib overrides it
393test_at_end_hook_ () {
394 :
395}
396
e1970ce4 397test_done () {
6e7b5aaf 398 GIT_EXIT_OK=t
2d84e9fb 399
1c0cc756
RJ
400 if test -z "$HARNESS_ACTIVE"
401 then
342e9ef2 402 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
8ef1abe5 403 mkdir -p "$test_results_dir"
dd78478f
FC
404 base=${0##*/}
405 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
8ef1abe5 406
c54e6be7
ML
407 cat >>"$test_results_path" <<-EOF
408 total $test_count
409 success $test_success
410 fixed $test_fixed
411 broken $test_broken
412 failed $test_failure
413
414 EOF
8ef1abe5 415 fi
41ac414e
JH
416
417 if test "$test_fixed" != 0
418 then
b73d9a23 419 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
41ac414e
JH
420 fi
421 if test "$test_broken" != 0
422 then
e8e51955 423 say_color warn "# still have $test_broken known breakage(s)"
b73d9a23
AS
424 fi
425 if test "$test_broken" != 0 || test "$test_fixed" != 0
426 then
427 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
428 msg="remaining $test_remaining test(s)"
11d54b8b 429 else
b73d9a23 430 test_remaining=$test_count
11d54b8b 431 msg="$test_count test(s)"
41ac414e 432 fi
e1970ce4 433 case "$test_failure" in
10b94e28 434 0)
5099b99d 435 # Maybe print SKIP message
bf4b7219
RJ
436 if test -n "$skip_all" && test $test_count -gt 0
437 then
438 error "Can't use skip_all after running some tests"
439 fi
5099b99d
ÆAB
440 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
441
1c0cc756
RJ
442 if test $test_external_has_tap -eq 0
443 then
b73d9a23 444 if test $test_remaining -gt 0
d87bd7c1
RJ
445 then
446 say_color pass "# passed all $msg"
447 fi
d998bd4a
ÆAB
448 say "1..$test_count$skip_all"
449 fi
abc5d372
JS
450
451 test -d "$remove_trash" &&
452 cd "$(dirname "$remove_trash")" &&
453 rm -rf "$(basename "$remove_trash")"
454
342e9ef2
TR
455 test_at_end_hook_
456
e1970ce4
JH
457 exit 0 ;;
458
459 *)
1c0cc756
RJ
460 if test $test_external_has_tap -eq 0
461 then
d998bd4a
ÆAB
462 say_color error "# failed $test_failure among $msg"
463 say "1..$test_count"
464 fi
5099b99d 465
e1970ce4
JH
466 exit 1 ;;
467
468 esac
469}
470
e4597aae 471if test -n "$valgrind"
4e1be63c 472then
4e1be63c
JS
473 make_symlink () {
474 test -h "$2" &&
475 test "$1" = "$(readlink "$2")" || {
476 # be super paranoid
477 if mkdir "$2".lock
478 then
479 rm -f "$2" &&
480 ln -s "$1" "$2" &&
481 rm -r "$2".lock
482 else
483 while test -d "$2".lock
484 do
485 say "Waiting for lock on $2."
486 sleep 1
487 done
488 fi
489 }
490 }
491
492 make_valgrind_symlink () {
36bfb0e5
JK
493 # handle only executables, unless they are shell libraries that
494 # need to be in the exec-path. We will just use "#!" as a
495 # guess for a shell-script, since we have no idea what the user
496 # may have configured as the shell path.
497 test -x "$1" ||
498 test "#!" = "$(head -c 2 <"$1")" ||
499 return;
4e1be63c
JS
500
501 base=$(basename "$1")
6cec5c68 502 symlink_target=$GIT_BUILD_DIR/$base
4e1be63c
JS
503 # do not override scripts
504 if test -x "$symlink_target" &&
505 test ! -d "$symlink_target" &&
506 test "#!" != "$(head -c 2 < "$symlink_target")"
507 then
508 symlink_target=../valgrind.sh
509 fi
efd92ffd
JS
510 case "$base" in
511 *.sh|*.perl)
512 symlink_target=../unprocessed-script
513 esac
4e1be63c
JS
514 # create the link, or replace it if it is out of date
515 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
516 }
517
518 # override all git executables in TEST_DIRECTORY/..
519 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
520 mkdir -p "$GIT_VALGRIND"/bin
6cec5c68 521 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
4e1be63c
JS
522 do
523 make_valgrind_symlink $file
524 done
ee0d7bf9
TR
525 # special-case the mergetools loadables
526 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
efd92ffd
JS
527 OLDIFS=$IFS
528 IFS=:
529 for path in $PATH
530 do
531 ls "$path"/git-* 2> /dev/null |
532 while read file
533 do
534 make_valgrind_symlink "$file"
535 done
536 done
537 IFS=$OLDIFS
4e1be63c
JS
538 PATH=$GIT_VALGRIND/bin:$PATH
539 GIT_EXEC_PATH=$GIT_VALGRIND/bin
540 export GIT_VALGRIND
952af351
TR
541 GIT_VALGRIND_MODE="$valgrind"
542 export GIT_VALGRIND_MODE
1c0cc756
RJ
543elif test -n "$GIT_TEST_INSTALLED"
544then
e4597aae
MO
545 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
546 error "Cannot run git from $GIT_TEST_INSTALLED."
6cec5c68 547 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
e4597aae
MO
548 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
549else # normal case, use ../bin-wrappers only unless $with_dashes:
6cec5c68 550 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
1c0cc756
RJ
551 if ! test -x "$git_bin_dir/git"
552 then
553 if test -z "$with_dashes"
554 then
e4597aae
MO
555 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
556 fi
557 with_dashes=t
558 fi
559 PATH="$git_bin_dir:$PATH"
6cec5c68 560 GIT_EXEC_PATH=$GIT_BUILD_DIR
1c0cc756
RJ
561 if test -n "$with_dashes"
562 then
6cec5c68 563 PATH="$GIT_BUILD_DIR:$PATH"
e4597aae 564 fi
4e1be63c 565fi
6cec5c68 566GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
8bfa6bd6 567unset GIT_CONFIG
8bfa6bd6 568GIT_CONFIG_NOSYSTEM=1
3c995beb 569GIT_ATTR_NOSYSTEM=1
8f323c00 570export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
49ccb087 571
5e87eae9
JH
572if test -z "$GIT_TEST_CMP"
573then
574 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
575 then
576 GIT_TEST_CMP="$DIFF -c"
577 else
578 GIT_TEST_CMP="$DIFF -u"
579 fi
580fi
581
6cec5c68 582GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
6fcca938 583export GITPERLLIB
6cec5c68 584test -d "$GIT_BUILD_DIR"/templates/blt || {
eea42069
JH
585 error "You haven't built things yet, have you?"
586}
e1970ce4 587
ac10a857 588if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
2fe40b63 589then
6cec5c68 590 GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
2fe40b63 591 export GITPYTHONLIB
6cec5c68 592 test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
2fe40b63
SR
593 error "You haven't built git_remote_helpers yet, have you?"
594 }
595fi
596
1c0cc756
RJ
597if ! test -x "$GIT_BUILD_DIR"/test-chmtime
598then
56cf9806
EW
599 echo >&2 'You need to build test-chmtime:'
600 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
601 exit 1
602fi
603
e1970ce4 604# Test repository
002d4ce8
JK
605TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
606test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
607case "$TRASH_DIRECTORY" in
608/*) ;; # absolute path is good
609 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
f423ef5f 610esac
91c8b825 611test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
38b074de 612rm -fr "$TRASH_DIRECTORY" || {
6e7b5aaf 613 GIT_EXIT_OK=t
8d14ac94
JH
614 echo >&5 "FATAL: Cannot prepare test area"
615 exit 1
616}
617
90cff968
AR
618HOME="$TRASH_DIRECTORY"
619export HOME
620
1c0cc756
RJ
621if test -z "$TEST_NO_CREATE_REPO"
622then
38b074de 623 test_create_repo "$TRASH_DIRECTORY"
342e9ef2 624else
38b074de 625 mkdir -p "$TRASH_DIRECTORY"
342e9ef2 626fi
1bd9c648
LW
627# Use -P to resolve symlinks in our working directory so that the cwd
628# in subprocesses like git equals our $PWD (for pathname comparisons).
38b074de 629cd -P "$TRASH_DIRECTORY" || exit 1
04ece593 630
d5d9de1b
JS
631this_test=${0##*/}
632this_test=${this_test%%-*}
04ece593
JH
633for skp in $GIT_SKIP_TESTS
634do
47e67d47
MG
635 case "$this_test" in
636 $skp)
0a6d4751 637 say_color info >&3 "skipping test $this_test altogether"
637ab29b 638 skip_all="skip all tests in $this_test"
04ece593
JH
639 test_done
640 esac
641done
f17e9fbb 642
8648732e
BC
643# Provide an implementation of the 'yes' utility
644yes () {
645 if test $# = 0
646 then
647 y=y
648 else
649 y="$*"
650 fi
651
652 while echo "$y"
653 do
654 :
655 done
656}
657
f17e9fbb
JS
658# Fix some commands on Windows
659case $(uname -s) in
660*MINGW*)
661 # Windows has its own (incompatible) sort and find
662 sort () {
663 /usr/bin/sort "$@"
664 }
665 find () {
666 /usr/bin/find "$@"
667 }
5397ea31
JS
668 sum () {
669 md5sum "$@"
670 }
4114156a
JS
671 # git sees Windows-style pwd
672 pwd () {
673 builtin pwd -W
674 }
ee9fb68c 675 # no POSIX permissions
6fd1106a 676 # backslashes in pathspec are converted to '/'
fb9a2bea 677 # exec does not inherit the PID
a94114ad 678 test_set_prereq MINGW
cfa96496 679 test_set_prereq NOT_CYGWIN
a31d0665
RJ
680 test_set_prereq SED_STRIPS_CR
681 ;;
682*CYGWIN*)
683 test_set_prereq POSIXPERM
a31d0665
RJ
684 test_set_prereq EXECKEEPSPID
685 test_set_prereq NOT_MINGW
cfa96496 686 test_set_prereq CYGWIN
a31d0665 687 test_set_prereq SED_STRIPS_CR
ee9fb68c
JS
688 ;;
689*)
690 test_set_prereq POSIXPERM
6fd1106a 691 test_set_prereq BSLASHPSPEC
fb9a2bea 692 test_set_prereq EXECKEEPSPID
3ba9ba8f 693 test_set_prereq NOT_MINGW
cfa96496 694 test_set_prereq NOT_CYGWIN
f17e9fbb
JS
695 ;;
696esac
704a3143 697
b082687c 698( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
1b19ccd2 699test -z "$NO_PERL" && test_set_prereq PERL
d4e1b47a 700test -z "$NO_PYTHON" && test_set_prereq PYTHON
8f852ce6 701test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
5e9637c6 702test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1b19ccd2 703
bb946bba 704# Can we rely on git's output in the C locale?
30955229
JN
705if test -n "$GETTEXT_POISON"
706then
707 GIT_GETTEXT_POISON=YesPlease
708 export GIT_GETTEXT_POISON
5e9637c6 709 test_set_prereq GETTEXT_POISON
30955229
JN
710else
711 test_set_prereq C_LOCALE_OUTPUT
712fi
bb946bba 713
cabdee2c
JH
714# Use this instead of test_cmp to compare files that contain expected and
715# actual output from git commands that can be translated. When running
716# under GETTEXT_POISON this pretends that the command produced expected
717# results.
718test_i18ncmp () {
719 test -n "$GETTEXT_POISON" || test_cmp "$@"
720}
721
127df8c6
JH
722# Use this instead of "grep expected-string actual" to see if the
723# output from a git command that can be translated either contains an
724# expected string, or does not contain an unwanted one. When running
725# under GETTEXT_POISON this pretends that the command produced expected
726# results.
727test_i18ngrep () {
728 if test -n "$GETTEXT_POISON"
729 then
730 : # pretend success
731 elif test "x!" = "x$1"
732 then
733 shift
734 ! grep "$@"
735 else
736 grep "$@"
737 fi
738}
739
20073274
AS
740test_lazy_prereq PIPE '
741 # test whether the filesystem supports FIFOs
742 rm -f testfifo && mkfifo testfifo
743'
744
04083f27
JH
745test_lazy_prereq SYMLINKS '
746 # test whether the filesystem supports symbolic links
747 ln -s x y && test -h y
748'
c91cfd19 749
ac39aa61
MG
750test_lazy_prereq CASE_INSENSITIVE_FS '
751 echo good >CamelCase &&
752 echo bad >camelcase &&
753 test "$(cat CamelCase)" != good
754'
755
5b0b5dd4
MG
756test_lazy_prereq UTF8_NFD_TO_NFC '
757 # check whether FS converts nfd unicode to nfc
758 auml=$(printf "\303\244")
759 aumlcdiar=$(printf "\141\314\210")
760 >"$auml" &&
761 case "$(echo *)" in
762 "$aumlcdiar")
763 true ;;
764 *)
765 false ;;
766 esac
767'
768
09feffb6
JK
769test_lazy_prereq AUTOIDENT '
770 sane_unset GIT_AUTHOR_NAME &&
771 sane_unset GIT_AUTHOR_EMAIL &&
772 git var GIT_AUTHOR_IDENT
773'
774
c91cfd19
ÆAB
775# When the tests are run as root, permission tests will report that
776# things are writable when they shouldn't be.
777test -w / || test_set_prereq SANITY
f838ce58
JK
778
779GIT_UNZIP=${GIT_UNZIP:-unzip}
780test_lazy_prereq UNZIP '
781 "$GIT_UNZIP" -v
782 test $? -ne 127
783'